/* Notice that this import includes the android subdirectory */
import junctionbox.android.*;
/* This import is required */
import android.view.MotionEvent;

/* For this sketch to run properly, the INTERNET permission must be set!
   Check the INTERNET box in Android>Sketch Permissions */

Dispatcher dispatcher;
Junction junction;

void setup() {
  /* If the Dispatcher is provided with a target IP address and port,
     it will pass them on to any Junction it creates */
  dispatcher = new Dispatcher(displayWidth, displayHeight, "127.0.0.1", 7000);
  
  junction = dispatcher.createJunction(displayWidth/2, displayHeight/2, 400, 400);
  
  junction.setShape(RECT);
  //junction.setShape(ELLIPSE);
  
  /* Use this to allow for 1 and 2 touch translation */
  //junction.allowTranslation(true);
  
  /* Use these to allow for 2 or 3 touch translation */
  //junction.allowTranslation(true, 2);
  //junction.allowTranslation(true, 3);
  
  /* Allow from 1 to 4 touches for translation */
  junction.allowTranslation(true, 1, 4);
  
  /* These are allowed as long as translation is generally allowed */
  /* Un-comment these to turn off translation along the x or y axis */
  //junction.allowTranslationX(false);
  //junction.allowTranslationY(false);
  
  /* Translation can be limited to specific parts of the interface */
  /* By default, translation is limited to the edges of the display */
  //junction.limitTranslationX(0, displayWidth/2);
  //junction.limitTranslationY(0, displayHeight/2);
  
  /* Translation can be mapped to OSC messages */
  junction.mapMessage(Action.TRANSLATE, "/translate/xy");
  //junction.mapMessage(Action.TRANSLATE_X, "/translate/x");
  //junction.mapMessage(Action.TRANSLATE_Y, "/translate/y");
  junction.mapMessage(Action.COUNT_CONTACTS, "/count/contacts");
  
  ellipseMode(CENTER);
  rectMode(CENTER);
  
  strokeWeight(4);
  smooth();
  
  textSize(24);
}

void draw() {
  background(200);

  /* Use red when at least one touch is within the Junction */
  if (junction.isActive()) {
    fill(0, 255, 0);
  }
  else {
    fill(255);
  }
  
  if (junction.getShape() == RECT) {
    rect(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  else {
    ellipse(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  
  /* Note that the values for center x,y are for Processing output.
     OSC message values have ranges that are always from 0-1. */
  fill(0);
  text("Center X: " + junction.getCenterX(), 30, 50);
  text("Center Y: " + junction.getCenterY(), 30, 80);
}

/* This method must be here to route touch events in Android */
public boolean dispatchTouchEvent(MotionEvent ev) {
  dispatcher.handleMotionEvent(ev);
  return true;
}

