/* Notice that this import includes the android subdirectory */
import junctionbox.android.*;
/* This import is required */
import android.view.MotionEvent;

/* For this sketch to run properly, the INTERNET permission must be set!
   Check the INTERNET box in Android>Sketch Permissions */

Dispatcher dispatcher;
Junction junction;

void setup() {
  dispatcher = new Dispatcher(displayWidth, displayHeight, "127.0.0.1", 7000);

  junction = dispatcher.createJunction(displayWidth/2, displayHeight/2, 400, 600);
  
  junction.setShape(ELLIPSE);
  //junction.setShape(RECT);
  
  /* NOTE: Rotation is not allowed by default */
  /* This enables 1 and 2 touch rotation */
  junction.allowRotation(true);
  
  /* Specify 2 touch rotation */
  //junction.allowRotation(true, 2);
  
  /* Set angle limits in radians */
  //junction.limitRotation(0, TWO_PI);
  
  /* OSC messages can be mapped to both the current angle and the number of rotations */
  junction.mapMessage(Action.ROTATE, "/rotate");
  //junction.mapMessage(Action.ROTATE_1, "/rotate1");
  //junction.mapMessage(Action.ROTATE_2, "/rotate2");
  junction.mapMessage(Action.COUNT_ROTATIONS, "/count/rotations");
  
  ellipseMode(CENTER);
  rectMode(CENTER);
  
  strokeWeight(4);
  smooth();

  textSize(24);
}

void draw() {
  background(200);
  
  fill(0);

  /* Show the current angle and the rotation count */
  text("Angle: " + junction.getAngle(), 30, 50);
  text("Rotations: " + junction.getRotationCount(), 30, 80);
  
  if (junction.isActive()) {
    fill(0, 255, 0);
  }
  else {
    fill(255);
  }
  
  pushMatrix();
  
  translate(junction.getCenterX(), junction.getCenterY());
  rotate(junction.getAngle());
  
  if (junction.getShape() == ELLIPSE) {
    ellipse(0, 0, junction.getWidth(), junction.getHeight());
  }
  else {
    rect(0, 0, junction.getWidth(), junction.getHeight());
  }
  
  /* Small circles to help track rotation */
  fill(255, 0, 0);
  ellipse(0, 0+junction.getHeight()/2, 20, 20);
  fill(0, 0, 255);
  ellipse(0, 0-junction.getHeight()/2, 20, 20);
  fill(0);
  ellipse(0, 0, 40, 40);
  
  popMatrix();
}

/* This method must be here to route touch events in Android */
public boolean dispatchTouchEvent(MotionEvent ev) {
  dispatcher.handleMotionEvent(ev);
  return true;
}

