import junctionbox.android.*;
import android.view.MotionEvent;

Dispatcher dispatcher;

Junction junction1;
Junction junction2;
Junction junction3;

Square square1;
Square square2;
Square square3;

/* Avoid duplicate code by creating this class */
class Square {
  void out(boolean on, float x, float y, float w, float h, float a) {
    if (on) {
      fill(0, 255, 0);
    }
    else {
      fill(255);
    }
    
    pushMatrix();
    translate(x, y);
    rotate(a);
    rect(0, 0, w, h);
    popMatrix();
  }
}

void setup() {
  dispatcher = new Dispatcher(displayWidth, displayHeight, "127.0.0.1", 7000);
  
  junction1 = dispatcher.createJunction(width/2, height/2, 3*width/4, 3*height/4);
  junction1.allowRotation(true);
  junction1.limitRotation(0, PI);
  
  /* Try allowing other kinds of inheritable interactions */
  //junction1.allowScaling(true);
  //junction1.allowTranslation(true);
  //junction1.allowTranslationX(false);
  //junction1.allowTranslationY(false);
  
  /* Create the subjunctions independent of the Dispatcher */
  junction2 = new Junction(width, height, width/2, height/2, width/2, height/2);
  junction3 = new Junction(width, height, width/2, height/2, width/4, height/4);
  
  /* Use addJunction() to have subjunctions inherit from the parent */
  junction1.addJunction(junction2);
  junction2.addJunction(junction3);
  
  rectMode(CENTER);
  strokeWeight(4);
  smooth();
  
  square1 = new Square();
  square2 = new Square();
  square3 = new Square();
}

void draw() {
  background(200);
  
  /* Draw a square for each Junction */
  square1.out(junction1.isActive(), junction1.getCenterX(), junction1.getCenterY(), junction1.getWidth(), junction1.getHeight(), junction1.getAngle());
  square2.out(junction2.isActive(), junction2.getCenterX(), junction2.getCenterY(), junction2.getWidth(), junction2.getHeight(), junction2.getAngle());
  square3.out(junction3.isActive(), junction3.getCenterX(), junction3.getCenterY(), junction3.getWidth(), junction3.getHeight(), junction3.getAngle());
}

/* This method must be here to route touch events in Android */
public boolean dispatchTouchEvent(MotionEvent ev) {
  dispatcher.handleMotionEvent(ev);
  return true;
}

