import junctionbox.*;

Dispatcher dispatcher;
Junction junction;
Simulator simulator;

void setup() {
  size(800, 800);
  
  /* If the Dispatcher is provided with a target IP address and port,
     it will pass them on to any Junction it creates */
  dispatcher = new Dispatcher(width, height, "127.0.0.1", 7000);
  
  simulator = new Simulator(width, height);
  
  junction = dispatcher.createJunction(width/2, height/2, width/2, height/2);
  
  junction.setShape(RECT);
  //junction.setShape(ELLIPSE);
  
  /* Use this to allow for 1-touch translation */
  junction.allowTranslation(true);
  
  /* These are allowed by default as long as translation is generally allowed */
  /* Un-comment these to turn off translation along the x or y axis */
  //junction.allowTranslationX(false);
  //junction.allowTranslationY(false);
  
  /* Translation can be limited to specific parts of the interface */
  /* By default, translation is limited to the edges of the display */
  //junction.limitTranslationX(0, displayWidth/2);
  //junction.limitTranslationY(0, displayHeight/2);
  
  /* Translation can be mapped to OSC messages */
  /* An OSC listener is needed to try this */
  junction.mapMessage(Action.TRANSLATE, "/translate/xy");
  //junction.mapMessage(Action.TRANSLATE_X, "/translate/x");
  //junction.mapMessage(Action.TRANSLATE_Y, "/translate/y");
  
  ellipseMode(CENTER);
  rectMode(CENTER);
  
  cursor(HAND);
  strokeWeight(4);
  smooth();
  
  textSize(24);
}

void draw() {
  background(200);

  simulator.mouse(mousePressed, mouseButton, mouseX, mouseY, pmouseX, pmouseY);
  
  if (junction.isActive()) {
    fill(0, 255, 0);
  }
  else {
    fill(255);
  }
  
  if (junction.getShape() == RECT) {
    rect(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  else {
    ellipse(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  
  /* Note that the values for center x,y are for Processing output.
     OSC message values have ranges that are always from 0-1. */
  fill(0);
  text("Center X: " + junction.getCenterX(), 30, 50);
  text("Center Y: " + junction.getCenterY(), 30, 80);
}

