import junctionbox.*;

/* Because the mouse only simulates one touch, two-touch scaling does not work for the mouse.
   Instead, scale the top of the green rectangle by selecting a new top edge withing the white
   rectangle. Change the bottom edge in the same way. */

Dispatcher dispatcher;
Junction junction;
Simulator simulator;
Contact[] touches;
float topY;
float bottomY;
float leftX;
float rightX;

void setup() {
  size(800, 800);
  
  dispatcher = new Dispatcher(width, height, "127.0.0.1", 7000);
  
  simulator = new Simulator(width, height);
  
  junction = dispatcher.createJunction(width/2, height/2, 400, 0.8*height);
  
  leftX = junction.getCenterX()-(junction.getWidth()/2);
  rightX = junction.getCenterX()+(junction.getWidth()/2);
  
  junction.setShape(RECT);
  //junction.setShape(ELLIPSE);
  
  /* Map the Y location of the contact since that is used to scale the rectangle */
  junction.mapMessage(Action.CONTACT_Y, "/contact/y");
  
  topY = 200;
  bottomY = 600;
  
  ellipseMode(CENTER);
  rectMode(CENTER);
  
  cursor(HAND);
  strokeWeight(4);
  smooth();
}

void draw() {
  background(200);

  simulator.mouse(mousePressed, mouseButton, mouseX, mouseY, pmouseX, pmouseY);
  
  touches = junction.getContacts();
  
  for (int i = 0; i < touches.length; i++) {
    float y = touches[i].getY();
    
    if (y < height/2) {
      topY = y;
    }
    else if (y > height/2) {
      bottomY = y;
    }
  }
  
  noStroke();
  /*if (junction.isActive()) {
    fill(0, 255, 0);
  }
  else {
    fill(255);
  }*/
  
  fill(255);
  if (junction.getShape() == RECT) {
    rect(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  else {
    ellipse(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  
  stroke(0);
  fill(0, 255, 0);
  quad(leftX, topY, rightX, topY, rightX, bottomY, leftX, bottomY);
}

