import junctionbox.*;

Simulator sim;
Dispatcher dis;

Junction junc1;
Junction junc2;
Junction junc3;

Square square1;
Square square2;
Square square3;

class Square {
  void out(boolean on, float x, float y, float w, float h, float a) {
    if (on) {
      fill(0, 255, 0);
    }
    else {
      fill(255);
    }
    
    pushMatrix();
    translate(x, y);
    rotate(a);
    rect(0, 0, w, h);
    popMatrix();
  }
}

void setup() {
  size(800, 800);
  
  sim = new Simulator(width, height);
  dis = new Dispatcher(width, height);
  
  junc1 = dis.createJunction(width/2, height/2, 3*width/4, 3*height/4);
  junc1.allowRotation(true);
  junc1.limitRotation(0, PI);
  //junc1.allowScaling(true);
  //junc1.allowTranslation(true);
  //junc1.allowTranslationX(false);
  //junc1.allowTranslationY(false);
  
  junc2 = new Junction(width, height, width/2, height/2, width/2, height/2);
  junc3 = new Junction(width, height, width/2, height/2, width/4, height/4);
  
  junc1.addJunction(junc2);
  junc2.addJunction(junc3);
  
  rectMode(CENTER);
  cursor(HAND);
  strokeWeight(4);
  smooth();
  
  square1 = new Square();
  square2 = new Square();
  square3 = new Square();
}

void draw() {
  background(200);
  
  sim.mouse(mousePressed, mouseButton, mouseX, mouseY, pmouseX, pmouseY);
  
  square1.out(junc1.isActive(), junc1.getCenterX(), junc1.getCenterY(), junc1.getWidth(), junc1.getHeight(), junc1.getAngle());
  square2.out(junc2.isActive(), junc2.getCenterX(), junc2.getCenterY(), junc2.getWidth(), junc2.getHeight(), junc2.getAngle());
  square3.out(junc3.isActive(), junc3.getCenterX(), junc3.getCenterY(), junc3.getWidth(), junc3.getHeight(), junc3.getAngle());
}
