import junctionbox.*;

/* For JunctionBox to work properly, TUIO must be enabled!
   See http://www.tuio.org/ for more information */

Dispatcher dispatcher;
Junction junction;

void setup() {
  size(displayWidth, displayHeight);
  
  dispatcher = new Dispatcher(displayWidth, displayHeight, "127.0.0.1", 7000);
  
  junction = dispatcher.createJunction(displayWidth/2, displayHeight/2, 400, 400);
  
  junction.setShape(RECT);
  //junction.setShape(ELLIPSE);
  
  /* Allow 2-touch scaling */
  junction.allowScaling(true);
  
  /* Scaling can be limited to either width or height
     If scaling is allowed, width and height are scalable unless turned off */
  //junction.allowScalingWidth(false);
  //junction.allowScalingHeight(false);
  
  /* Limits can be set on width, height, or both
     NOTE: the defaults for width and height are the size of the display */
  //junction.limitScalingWidth(600, 600);
  //junction.limitScalingHeight(600, 600);
  
  /* Map OSC messages to either changes in width, height, or both */
  junction.mapMessage(Action.SCALE, "/scale");
  //junction.mapMessage(Action.SCALE_WIDTH, "/scale/width");
  //junction.mapMessage(Action.SCALE_HEIGHT, "/scale/height");
  
  ellipseMode(CENTER);
  rectMode(CENTER);
  
  noCursor();
  strokeWeight(4);
  smooth();
  
  textSize(24);
}

void draw() {
  background(200);
  
  if (junction.isActive()) {
    fill(0, 255, 0);
  }
  else {
    fill(255);
  }
  
  if (junction.getShape() == RECT) {
    rect(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  else {
    ellipse(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  
  /* Show the current values for width and height */
  fill(0);
  text("Width: " + junction.getWidth(), 30, 50);
  text("Height: " + junction.getHeight(), 30, 80);
}

