import junctionbox.*;

Dispatcher dispatcher;
Junction junction;
Contact[] touches;

void setup() {
  size(displayWidth, displayHeight);
  
  dispatcher = new Dispatcher(displayWidth, displayHeight, "127.0.0.1", 7000);
  
  junction = dispatcher.createJunction(displayWidth/2, displayHeight/2, 400, 400);
  
  junction.setShape(RECT);
  //junction.setShape(ELLIPSE);
  
  /* The following mappings are for rectangles only */
  junction.mapMessage(Action.CONTACT, "/contact/xy");
  //junction.mapMessage(Action.CONTACT_X, "/contact/x");
  //junction.mapMessage(Action.CONTACT_Y, "/contact/y");
  
  /* This mapping works for ellipses */
  //junction.mapMessage(Action.CONTACT_R, "/contact/r");
  
  /* Messages can be sent whenever the number of touches changes */
  junction.mapMessage(Action.COUNT_CONTACTS, "/count/contacts");
  
  ellipseMode(CENTER);
  rectMode(CENTER);
  
  noCursor();
  strokeWeight(4);
  smooth();
  
  textSize(24);
}

void draw() {
  background(200);
  
  if (junction.isActive()) {
    fill(0, 255, 0);
  }
  else {
    fill(255);
  }
  
  if (junction.getShape() == RECT) {
    rect(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  else {
    ellipse(junction.getCenterX(), junction.getCenterY(), junction.getWidth(), junction.getHeight());
  }
  
  touches = junction.getContacts();
  
  /* Display a blue circle for each touch */
  for (int i = 0; i < touches.length; i++) {
    fill(0, 0, 255);
    ellipse(touches[i].getX(), touches[i].getY(), 50, 50);
  }
  
  /* Show the touch count inside the Junction */
  fill(0);
  text("Contact count: " + junction.getContactCount(), 30, 35);
}

